const clientID = 0;
const clientIDString = "msmsgs@msnmsgr.com";
const clientIDCode = "Q1P7W2E4J9R8U3S5";
const MSNPort = "1863";

function MSNObject() {
  // object-specific
  this.bundle = getStringBundle("chrome://msnmsgr/locale/msnmsgr.properties");

  // user-related
  this.passport = '';
  this.password = '';
  this.nickname = '';
  this.status = "HDN";
  this.GTC = "A";
  this.BLP = "AL";
  this.contactlist = new Array();
  this.sl = 0;
  this.unreadEmails = 0;

  // connection-related
  this.socket = new Socket();
  this._TRID = 0;
  this.data = '';
  this.qng = true;
  this.challenge = '';
  this.sessions = new Array();

  this.__defineGetter__("TrID", function() {
    this._TRID++;
    return this._TRID;
  });

  this.__defineSetter__("TrID", function(id) {
    this._TRID = id;
  });

  this.__defineGetter__("isConnected", function() {
    return this.socket.isConnected;
  });

  this.__defineGetter__("platform", function() {
    return "win 4.00 i386";
  });

  this.__defineGetter__("locale", function() {
    return this.bundle.GetStringFromName("localeID");
  });
}

MSNObject.prototype.logon = function(name, pass, initstat) {
  this.passport = name;
  this.password = pass;
  this.status = initstat;
  this.socket.connect("messenger.hotmail.com", MSNPort, this);
  loginProgress(0, "loginDS");
}

MSNObject.prototype.logout = function() {
  this.closeSessions();
  if (this.isConnected) {
    this.socket.sendData('OUT\r\n');
    this.socket.disconnect();
  }
  clearTimeout(this.pinger);
  clearInterval(this.slUpdater);
  this.socket = new Socket();
  this.contactlist = new Array();
}

MSNObject.prototype.onConnect = function() {
  this.socket.startAsyncRead();
  this.socket.sendData('VER ' + this.TrID + ' MSNP8 CVR0\r\n', 60000);
}

MSNObject.prototype.onClose = function() {
  this.socket = new Socket();
  document.getElementById("signin-button").disabled = false;
  document.getElementById("main-pages").selectedIndex = 0;
}

MSNObject.prototype.onDataAvailable = function(count) {
  this.data += this.socket.readData(count);
  while (this.data != '') {
    var i = this.data.indexOf('\r\n');
    if (i == -1) { return }
    var data = this.data.substr(0, i);
    this.data = this.data.substr(i+2);
    dump("<<< " + data + '\n');
    var param = data.split(" ");
    switch (param[0]) {
      case "VER":
        this.socket.sendData('CVR ' + this.TrID + ' ' + this.locale + ' ' + this.platform + ' MSNMSGR 5.0.0575 MSMSGS ' + this.passport + '\r\n', 60000);
        break;
      case "CVR":
        this.socket.sendData('USR ' + this.TrID + ' TWN I ' + this.passport + '\r\n', 60000);
      case "XFR":
        if (param[2] == "NS") {
          this.socket.disconnect(1);
          var host = param[3].split(":");
          this.TrID = 0;
          this.socket = new Socket();
          this.socket.connect(host[0], host[1], this);
          loginProgress(20, "loginNS");
        }
        else if (param[2] == "SB") {
          var host = param[3].split(":");
          this.newSession.open(host[0], host[1], param[5]);
          delete this.newSession;
        }
        break;
      case "USR":
        if (param[3] == "S") {
          this.challenge = param[4];
          var keyPos = this.challenge.indexOf("kv") + 3;
          var keyEndPos = this.challenge.indexOf(",", keyPos);
          this.kv = this.challenge.substr(keyPos, keyEndPos - keyPos);
          var httpsocket = new HttpSocket();
          dump("Opening connection to Passport Nexus...\r\n");
          httpsocket.openNexus("https://nexus.passport.com/rdr/pprdr.asp", this);
          loginProgress(40, "authenticating");
        }
        else if (param[2] == "OK") {
          this.nickname = unescape(uniConvertTo(param[4]));
          this.socket.sendData('SYN ' + this.TrID + ' 0' + '\r\n', 60000);
          this.ping();
          loginProgress(80, "gettingContacts");
        }
        break;
      case "SYN":
        if (param[3] != "0") {
          this.contactsLeft = parseInt(param[3]);
        }
        else {
          nicknameChanged(this.nickname);
          this.changeStatus(this.status);
          loginSuccessful();
        }
        break;
      case "GTC":
        this.GTC = param[1];
        break;
      case "BLP":
        this.BLP = param[1];
        break;
      case "PRP":
        // no phone support
        break;
      case "LSG":
        // no groups support for now
        break;
      case "LST":
        this.contactlist[param[1]] = new MSNContact(param[1], uniConvertTo(param[2]), "FLN", param[3], 0);
        if ((param[3] & 14) == 8) {
          if (this.GTC == "A") {
            window.openDialog("chrome://msnmsgr/content/contactaddprompt.xul", "_blank", "chrome,resizable", param[1], param[2]);
          }
          else {
            this.contactlist[param[1]].lists += 4;
          }
        }
        this.contactsLeft--;
        if (this.contactsLeft == 0) {
          nicknameChanged(this.nickname);
          setupContactlist(this.getForwardList());
          this.changeStatus(this.status);
          loginSuccessful();
          delete this.contactsLeft;
        }
        break;
      case "BPR":
        // no phone support
        break;
      case "QNG":
        this.qng = true;
        break;
      case "MSG":
        if (this.data >= param[3]) {
          var msgData = this.data.substr(0, param[3]);
          this.data = this.data.substr(param[3]);
          var msgParts = msgData.split('\r\n\r\n');
          var headers = parseHeaders(msgParts[0]);
          switch (headers["content-type"]) {
            case "text/x-msmsgsprofile; charset=UTF-8":
              this.sid = headers["sid"];
              this.mspauth = headers["mspauth"];
              this.slUpdater = setInterval(function() { window.client.sl++; }, 1000);
              break;
            case "text/x-msmsgsinitialemailnotification; charset=UTF-8":
              var msgData = parseHeaders(msgParts[1]);
              this.unreadEmails = parseInt(msgData["inbox-unread"]);
              updateEmailItem(this.unreadEmails);
              break;
            case "text/x-msmsgsemailnotification; charset=UTF-8":
              this.unreadEmails++;
              updateEmailItem(this.unreadEmails);
              break;
            case "text/x-msmsgsactivemailnotification; charset=UTF-8":
              var msgData = parseHeaders(msgParts[1]);
              if (msgData["src-folder"] == "ACTIVE") {
                this.unreadEmails -= parseInt(msgData["message-delta"]);
                updateEmailItem(this.unreadEmails);
              }
              break;
          }
        }
      case "NOT":
        // strip it out for now
        this.data = this.data.substr(param[1]);
        break;
      case "ILN":
        var contact = this.contactlist[param[3]];
        var contactBlocked = this.isContactInList(contact.email, "BL");
        if (contact.status == "FLN") {
          var uniNickname = unescape(uniConvertTo(param[4]));
          if (uniNickname != contact.nickname) {
            contact.nickname = uniNickname;
            this.socket.sendData('REA ' + this.TrID + ' ' + contact.email + ' ' + param[4] + '\r\n');
          }
          contact.status = param[2];
          contact.clientID = param[5];
          addOnlineContact(contact.email, contact.nickname, contact.status, contactBlocked);
        }
        break;
      case "NLN":
        var contact = this.contactlist[param[2]];
        var uniNickname = unescape(uniConvertTo(param[3]));
        var contactBlocked = this.isContactInList(contact.email, "BL");
        if (contact.status == "FLN") {
          if (contact.nickname != uniNickname) {
            contact.nickname = uniNickname;
            this.socket.sendData('REA ' + this.TrID + ' ' + contact.email + ' ' + param[3] + '\r\n');
          }
          contact.status = param[1];
          contact.clientID = param[4];
          addOnlineContact(contact.email, contact.nickname, contact.status, contactBlocked);
          this.notifySessionsOfContactChange(contact.email);
        }
        else {
          if (contact.status != param[1]) {
            contact.status = param[1];
            contactStatusChanged(contact.email, contact.status, contactBlocked);
          }
          if (contact.nickname != uniNickname) {
            contact.nickname = uniNickname;
            this.socket.sendData('REA ' + this.TrID + ' ' + contact.email + ' ' + param[3] + '\r\n');
            contactNicknameChanged(contact.email, contact.nickname);
          }
          if (contact.clientID != param[4]) {
            contact.clientID = param[4];
          }
          this.notifySessionsOfContactChange(contact.email);
        }
        break;
      case "FLN":
        var contact = this.contactlist[param[1]];
        var contactBlocked = this.isContactInList(contact.email, "BL");
        if (contact.status != "FLN") {
          contact.status = "FLN";
          addOfflineContact(contact.email, contactBlocked);
          this.notifySessionsOfContactChange(contact.email);
        }
        break;
      case "CHL":
        var md5 = hex_md5(param[2] + clientIDCode);
        this.socket.sendData('QRY ' + this.TrID + ' ' + clientIDString + ' ' + md5.length + '\r\n' + md5, 60000);
        dump('\r\n');
        break;
      case "CHG":
        this.status = param[2];
        statusChanged(this.status);
        break;
      case "REA":
        if (param[3] == this.passport) {
          this.nickname = unescape(uniConvertTo(param[4]));
          nicknameChanged(this.nickname);
        }
        break;
      case "ADD":
        if (typeof(this.contactlist[param[4]]) == "undefined") {
          this.contactlist[param[4]] = new MSNContact(param[4], param[5], "FLN", 0, 0);
        }
        var contact = this.contactlist[param[4]];
        contact.lists += this.getListNumber(param[2]);
        if (param[2] == "FL") {
          addContact(contact.email, contact.nickname, "FLN", this.isContactInList(contact.email, "BL"));
        }
        if (param[2] == "RL" && (contact.lists & 14) == 8) {
          if (this.GTC == "A") {
            window.openDialog("chrome://msnmsgr/content/contactaddprompt.xul", "_blank", "chrome,resizable", contact.email, contact.nickname);
          }
          else {
            contact.lists += 2;
          }
        }
        break;
      case "REM":
        var contact = this.contactlist[param[4]];
        contact.lists -= this.getListNumber(param[2]);
        if (param[2] == "FL") {
          removeContact(param[4]);
        }
        break;
      case "RNG":
        var SB = param[2].split(":");
        setupIncomingSession(param[5], SB[0], SB[1], param[4], param[1]);
        break;
      case "URL":
        var login = this.passport.substr(0, this.passport.indexOf("@"));
        var sl = this.sl;
        var rru = param[2];
        if (typeof(this.composeTo) != "undefined") {
          rru += "?mailto=1&to=" + this.composeTo;
          delete this.composeTo;
        }
        var creds = hex_md5(this.mspauth + sl + this.password);
        loginEmail(param[3], login, this.passport, this.sid, this.kv, param[4], sl, rru, this.mspauth, creds);
        break;
      case "201":
        showError("Err_201");
        break;
      case "209":
        showError("Err_209");
        break;
      case "210":
        showError("Err_210");
        break;
      case "500":
        loginFailed("Err_500");
        break;
      case "540":
        loginFailed("Err_540");
        break;
      case "601":
        loginFailed("Err_601");
        break;
      case "800":
        showError("Err_800");
        break;
      case "910":
        loginFailed("Err_910_921");
        break;
      case "911":
        loginFailed("Err_911");
        break;
      case "913":
        delete this.newSession;
        showError("Err_913");
        break;
      case "921":
        loginFailed("Err_910_921");
        break;
    }
  }
}

MSNObject.prototype.onNexusDataAvailable = function(status, httpsocket) {
  loginserverurl = "https://" + extractFromHeader(httpsocket.socket.getResponseHeader("PassportURLs"), "DALogin");
  dump("Login Server URL received. Opening connection to Login Server...\r\n");
  httpsocket.openLogin(loginserverurl, this.passport, this.password, this.challenge, this);
}

MSNObject.prototype.onLoginDataAvailable = function(status, httpsocket) {
  switch (status) {
    case 200:
      var ticket = extractFromHeader(httpsocket.socket.getResponseHeader("Authentication-Info"), "from-PP");
      ticket = ticket.substr(1, ticket.length - 2);
      dump("Ticket received. Sending ticket to Notification Server...\n");
      this.socket.sendData('USR ' + this.TrID + ' TWN S ' + ticket + '\n', 60000);
      loginProgress(60, "sendingTicket");
      break;
    case 302:
      dump("We\'re being redirected!\n");
      break;
    case 401:
      var header = httpsocket.socket.getResponseHeader("WWW-Authenticate");
      dump(header);
      loginFailed("Err_911");
      break;
    default:
      dump("Unexpected error number: " + status + '\n');
      break;
  }
}

MSNObject.prototype.changeStatus = function(status) {
  this.socket.sendData('CHG ' + this.TrID + ' ' + status + ' ' + clientID + '\r\n', 15000);
}

MSNObject.prototype.changeNickname = function(nickname) {
  this.socket.sendData('REA ' + this.TrID + ' ' + this.passport + ' ' + escape(nickname) + '\r\n', 15000);
}

MSNObject.prototype.addContact = function(email, list) {
  var group = 0;
  if (list == "FL") {
    this.socket.sendData('ADD ' + this.TrID + ' ' + list + ' ' + email + ' ' + email + ' ' + group + '\r\n', 60000);
  }
  else {
    this.socket.sendData('ADD ' + this.TrID + ' ' + list + ' ' + email + ' ' + email + '\r\n', 60000);
  }
}

MSNObject.prototype.removeContact = function(email, list) {
  var group = 0;
  if (list == "FL") {
    this.socket.sendData('REM ' + this.TrID + ' ' + list + ' ' + email + ' ' + group + '\r\n', 60000);
  }
  else {
    this.socket.sendData('REM ' + this.TrID + ' ' + list + ' ' + email + '\r\n', 60000);
  }
}

MSNObject.prototype.getListNumber = function(list) {
  var listNumber;
  switch (list) {
    case "FL":
      listNumber = 1;
      break;
    case "AL":
      listNumber = 2;
      break;
    case "BL":
      listNumber = 4;
      break;
    case "RL":
      listNumber = 8;
      break;
  }
  return listNumber;
}

MSNObject.prototype.getForwardList = function() {
  var forwardList = new Array();
  for (var email in this.contactlist) {
    var contact = this.contactlist[email];
    if ((contact.lists & 1) == 1) {
      forwardList.push(new MSNContact(contact.email, contact.nickname, contact.status, contact.lists, contact.clientID));
    }
  }
  return forwardList;
}

MSNObject.prototype.isContactInList = function(email, list) {
  var isInList = false;
  var listNumber = this.getListNumber(list);
  if ((this.contactlist[email].lists & listNumber) == listNumber) {
    isInList = true;
  }
  return isInList;
}

MSNObject.prototype.getContact = function(email) {
  var contact = new MSNContact(email, this.contactlist[email].nickname,
    this.contactlist[email].status, 0, this.contactlist[email].clientID);
  return contact;
}

MSNObject.prototype.getContactStatus = function(email) {
  return this.contactlist[email].status;
}

MSNObject.prototype.grabSession = function(session) {
  this.newSession = session;
  this.socket.sendData('XFR ' + this.TrID + ' SB\r\n', 60000);
}

MSNObject.prototype.registerSession = function(sessionID, session) {
  this.sessions[sessionID] = session;
}

MSNObject.prototype.unregisterSession = function(sessionID) {
  delete this.sessions[sessionID];
}

MSNObject.prototype.closeSessions = function() {
  for (var sessionID in this.sessions) {
    var session = this.sessions[sessionID];
    session.close();
  }
}

MSNObject.prototype.getSessionWindow = function(email) {
  var win = null;
  for (var sessionID in this.sessions) {
    var session = this.sessions[sessionID];
    var contactID = session.getFirstContactID();
    if (contactID == email && session.getContactCount() == 1) {
      win = session.getWindow();
    }
  }
  return win;
}

MSNObject.prototype.notifySessionsOfContactChange = function(email) {
  var changedContact = this.contactlist[email];
  for (var sessionID in this.sessions) {
    var session = this.sessions[sessionID];
    var contactID = session.getContact(email);
    if (contactID != null) {
      var contact = new MSNContact(email, changedContact.nickname,
        changedContact.status, changedContact.lists, changedContact.clientID);
      session.contactChanged(contact);
    }
  }
}

MSNObject.prototype.requestEmailURL = function(inboxOrEmail) {
  var request;
  if (inboxOrEmail == "INBOX") {
    request = inboxOrEmail;
  }
  else {
    request = "COMPOSE";
    this.composeTo = inboxOrEmail;
  }
  this.socket.sendData('URL ' + this.TrID + ' ' + request + '\r\n');
}

MSNObject.prototype.ping = function() {
  if (this.qng == true) {
    this.qng = false;
    client.socket.sendData('PNG\r\n', 60000);
    this.pinger = setTimeout("window.client.ping()", 50000);
  }
}

function extractFromHeader(headervalue, fieldkey) {
  var field = headervalue.substr(headervalue.search(fieldkey));
  return field.substr(fieldkey.length + 1, field.search(",") - (fieldkey.length + 1));
}