const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);

const PREF_CTRID = "@mozilla.org/preferences-service;1";
const nsIPrefService = Components.interfaces.nsIPrefService;
const nsIPrefBranch = Components.interfaces.nsIPrefBranch;
const nsIPrefBranchInternal = Components.interfaces.nsIPrefBranchInternal;
const prefService = Components.classes[PREF_CTRID].getService(nsIPrefService);
const prefBranch = prefService.getBranch("extensions.msnmsgr.");

const XHTML = "http://www.w3.org/1999/xhtml";
const uniConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                      .createInstance(Components.interfaces.nsIScriptableUnicodeConverter)
uniConverter.charset = "UTF-8";

function getStringBundle(path) {
  var strBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"]
                           .getService(Components.interfaces.nsIStringBundleService);
  return strBundleService.createBundle(path); 
}

function openWindowOnce(url, type, features) {
  var recentWindow = kWindowMediator.getMostRecentWindow(type);
  if (recentWindow != null) {
    recentWindow.focus();
  }
  else {
    window.openDialog(url, type, features);
  }
}

function parseHeaders(headers) {
  var header = headers.split('\r\n');
  return parseFields(header, ": ");
}

function parseFields(fields, splitString) {
  var parsedFields = new Array();
  for (var field in fields) {
    var parsedField = fields[field].split(splitString);
    parsedFields[parsedField[0].toLowerCase()] = parsedField[1];
  }
  return parsedFields;
}

function uniConvertTo(chunk) {
  return uniConverter.ConvertToUnicode(chunk);
}

function uniConvertFrom(chunk) {
  return uniConverter.ConvertFromUnicode(chunk);
}